import java.net.*;  // for Socket
import java.io.*;   // for IOException and Input/OutputStream

public class if11_lan 
{
	private int bytesRcvd,bytesSent;
	private byte[] rcvBuffer = new byte[256];	

	public if11_lan()
	{
		bytesRcvd = 0;
		bytesSent = 0;		
	}
	/**------------------Initialize Device-----------------------------------*/
	public int init_LAN(InputStream in, OutputStream out) throws IOException,
			InterruptedException
	{
		String str =new String("E0 73;V0 73;TCPANSWERBACK 1\n");
		// Convert string to bytes for writing to output stream
		byte[] byteBuffer = str.getBytes();
		// Send the encoded string to the if11
		out.write(byteBuffer);
		Thread.sleep(1000); //Wait one second
		// Receive the response from the device
  		if ((bytesRcvd = in.read(rcvBuffer,0,9)) != 9)
			return -1;
		return 0;
	}
	/**---------------------clear matrix-------------------------------------*/
	public int matrix_clear(InputStream in,OutputStream out) throws IOException 
	{
		String str = new String("C\n");
		// Convert string to bytes for writing to output stream
		byte[] byteBuffer = str.getBytes();
		// Send the encoded string to the if11
		out.write(byteBuffer);
		// Receive the response from the device
  		if ((bytesRcvd = in.read(rcvBuffer,0,3)) == -1)
			return -1;
		return rcvBuffer[0];
	}
	/**------------------switchpoint operations-----------------------------*/
	public int point_ops(InputStream in, OutputStream out,char cmd,int mtx,
		int mod,int rly) throws IOException, InterruptedException
	{
		//Format command string to send to device
		String cmd_line = String.format("%c%d %d %d\n",cmd,mtx,mod,rly);
		// Convert string to bytes for writing to output stream
		byte[] byteBuffer = cmd_line.getBytes();
		// Send the encoded string to the if11
		out.write(byteBuffer);  
		Thread.sleep(100); //Wait 1/10 second
    		// Receive the response from the device		
  		if ((bytesRcvd = in.read(rcvBuffer,0,3)) == -1)
			return -1;
       		return rcvBuffer[0];	
	}
}