import java.net.*;  // for Socket
import java.io.*;   // for IOException and Input/OutputStream

public class if11_lantester
{
	static final int N_MODS = 4;
	static final int N_RLYS = 12;

	/**-----------------test if11 utility functions---------------------------------------*/

	public static void main(String[] args) throws IOException, InterruptedException 
	{
		if  (args.length != 2) // Test for correct # of args. IP Address and Port
      			throw new IllegalArgumentException("Parameter(s): <IP Address> [<Port>]");
		
    		String server = args[0];       // Server name or IP address
    		int servPort = Integer.parseInt(args[1]);  // Port Number

  		// Create socket that is connected to server on specified port
   		Socket socket = new Socket(server, servPort);
   		System.out.println("Connected to server...sending string");
		InputStream in = socket.getInputStream();
    		OutputStream out = socket.getOutputStream();
  		
  		if11_lan if11 = new if11_lan();

		// Initialize Device: Turn Verbose & Echo off, Answerback on
		if (if11.init_LAN(in,out) < 0)
			throw new SocketException("Error Initializing Device");

		// Clear Device: Unlatch all relays
		if (if11.matrix_clear(in,out) != 48)
			throw new SocketException("Error clearing Device");

		// Latch and Unlatch Relays
		for (int mod =0; mod < N_MODS; mod++)
		{
			for (int rly=0;rly<N_RLYS;rly++)
			{
				if (if11.point_ops(in,out,'L',0,mod,rly) != 49)
				{
					System.out.printf("Error latching Mod %d Rly %d\n",mod,rly);
					break;
				}
				System.out.printf("Latched Mod %d Rly %d\n",mod,rly);
				if (if11.point_ops(in,out,'U',0,mod,rly) != 48)
				{
					System.out.printf("Error unlatching Mod %d Rly %d\n",mod,rly);
					break;
				}
				System.out.printf("Unlatched Mod %d Rly %d\n",mod,rly);
			}
		}

   		socket.close();  // Close the socket and its streams
	}
}	